/* nuclear.c -- Nuclei Wars -- an Atomino -style game for TI85 */
/*                                                             */
/* this time with a 12x8 playfield                             */
/* coded in 5 hours on 13th of November 1997 which of one hour */
/* was used for thinking the recursive routines...             */
/* the code is a little crappy (all those "remarks") but read  */
/* it if you want...                                           */
/*                                                             */
/* Small mods (abt. 10 minutes coding, 30 minutes debugging)   */
/*to the code made on 17th of November 1997 from Dape's request*/
/*                                                             */
/* Controls? Well, here goes:                                  */
/*                                                             */
/* arrows - move                                               */
/* 2nd - put the atom where the cursor is (surprise surprise)  */
/* more - pause (even bigger surprise)                         */
/* del - teacher key (quit'n'save)                             */
/*                                                             */
/* the "white ball" atoms have 1 electron, "black balls" 2,    */
/* "black ball with a line going through it" 3 and "black ball */
/* with a dot" 4 (see sprite data)                             */
/*                                                             */
/* Every placed atom decreases one from its own electrons per  */
/* one of its neighbors electrons (ever heard of chemistry...?)*/
/* (or, more appropriately, the electrons make a bond which    */
/* holds the resulting molecule together, but in this game they*/
/*are just removed from the screen to make the view more clear)*/
/* If you didn't get it, experiment around... it's actually    */
/* quite simple...                                             */
/*                                                             */
/* (C) Tiger/Istar 1997                                        */


/********************************
             D A T A
 ********************************/

char atoms[8][12]; /*@ GRAPH_MEM;*/
char electrons[8][12]; /*@ GRAPH_MEM + 128;*/
char fill[8][12]; /*@ GRAPH_MEM + 256;*/

int x; /*@ GRAPH_MEM + 384;*/
int y; /*@ GRAPH_MEM + 403;*/

int sx; /*@ GRAPH_MEM + 386;*/
int sy; /*@ GRAPH_MEM + 388;*/

int x3; /*@ GRAPH_MEM + 399;*/
int y3; /*@ GRAPH_MEM + 401;*/

char key @ GRAPH_MEM + 390;
unsigned char i; /*@ GRAPH_MEM + 391;*/
unsigned char k; /*@ GRAPH_MEM + 392;*/
unsigned char foo;

char next[5]; /*@ GRAPH_MEM + 393;*/

char newat[16] = { 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4 };

char atom; /*@ GRAPH_MEM + 398;*/
char oldatom;

int looper; /*@ GRAPH_MEM + 402;*/

int maxloop;

char getky @ GRAPH_MEM + 403;

int score;
int hiscore;

int whoops;
int waldo;

int difficulty;

char teacher;

unsigned char atomspr[4][4]={bin2dec(00011000),
                             bin2dec(00100100),
                             bin2dec(00100100),
                             bin2dec(00011000),

                             bin2dec(00011000),
                             bin2dec(00111100),
                             bin2dec(00111100),
                             bin2dec(00011000),

                             bin2dec(00011000),
                             bin2dec(00101100),
                             bin2dec(00110100),
                             bin2dec(00011000),

                             bin2dec(00011000),
                             bin2dec(00110100),
                             bin2dec(00111100),
                             bin2dec(00011000) };

unsigned char cursor[4]= { bin2dec(00100100),
                           bin2dec(00000000),
                           bin2dec(00000000),
                           bin2dec(00100100) };



/********************************
       F U N C T I O N S
 ********************************/

/*****************************/
/* update next atoms display */
/*****************************/

void updnext()
{
/* erase old atoms from screen */

for(k=50;k<54;k++)
    for(i=98;i<124;i++)
        pixel_off(i,63-k);

for(k=57;k<61;k++)
    for(i=98;i<106;i++)
        pixel_off(i,63-k);     /* erase current atom display */

/* and draw new ones */

i=0;
for(sx=96;sx<126;sx+=6)
    {
    if(next[i]-1>=0)
        sprx2(atomspr[next[i]-1],4,sx,50);
    i++;
    }

if(atom-1>=0)
    sprx2(atomspr[atom-1],4,96,57);     /* draw current atom */
}

/****************************************************************/
/* draw a single atom with electrons at GRID COORDINATES x2, y2 */
/****************************************************************/

void drawatom(int x2, int y2)
{
sy=y2*8+2;
sx=x2*8;

/*
for(y3=sy-2;y3<sy+6;y3++)
    for(x3=sx;x3<sx+8;x3++)
        pixel_off((unsigned char)x3,63-(unsigned char)y3);
*/

if(atoms[y2][x2]>0)
    sprx2(atomspr[atoms[y2][x2]-1],4,sx,sy);

if(electrons[y2][x2]>0)
    pixel_on((unsigned char)sx+1,63-((unsigned char)sy-1));
if(electrons[y2][x2]>1)
    pixel_on((unsigned char)sx+6,63-((unsigned char)sy-1));
if(electrons[y2][x2]>2)
    pixel_on((unsigned char)sx+1,63-((unsigned char)sy+4));
if(electrons[y2][x2]>3)
    pixel_on((unsigned char)sx+6,63-((unsigned char)sy+4));
}

/******************************/
/* draw atoms (and electrons) */
/******************************/

void drawatoms()
{
for(whoops=0;whoops<8;whoops++)
    for(waldo=0;waldo<12;waldo++)
        drawatom(waldo,whoops);
}

/******************/
/* draw statusbar */
/******************/

void drawview()
{
clrscr();
for(i=0;i<64;i++)
    pixel_on(96,i);     /* a real line function would be handy... */
gotoxym(98,1);
printsm("Nuclei");
gotoxym(98,9);
printsm("Wars");
gotoxym(98,16);
printdm(difficulty);    /* show current level */
gotoxym(98,24);
printdm(score);
gotoxym(98,32);
printdm(hiscore);

gotoxym(98,42);
printsm("Next");

updnext();   /* update new atoms section */
drawatoms(); /* draw playfield */
}

/***************************/
/* get an atom from next[] */
/***************************/

void getatom()
{
atom=next[0];
for(i=0;i<4;i++)
    next[i]=next[i+1];

next[4]=0;
}

/*****************************/
/* make a new atom to next[] */
/*****************************/

char newatom()
{
i=0;
while(i<5)  /* get first free next[] place */
    {
    if(next[i]==0) break;
    i++;
    }

if(i==5) return 1;  /* no-can-do, array full (== game over) */

next[i]=newat[(rand() & 0x0F)];

return 0;
}

/*****************/
/* place an atom */
/*****************/

char placeatom()
{
if(atoms[y][x]==0)
    {
    atoms[y][x]=atom;
    electrons[y][x]=atom;

 /*   _randdirc:
    i=rand() & 0x03;    /* get random direction */

  /*  switch(i)
        {
        case 0:
            if(y==0) goto _randdirc;
            break;
        case 1:
            if(x==11) goto _randdirc;
            break;
        case 2:
            if(y==7) goto _randdirc;
            break;
        case 3:
            if(x==0) goto _randdirc;
        }

    foo=i;  */

    i=0;

    _newcheck:

    if(i==4)
        return 0;

    if(electrons[y][x]==0) return 0;

    k=0;

    switch(i)
        {
        case 0:
            if(y==0)
                {
                i++;
                goto _newcheck;
                }
            k=electrons[y-1][x];
            break;
        case 1:
            if(x==11)
                {
                i++;
                goto _newcheck;
                }
            k=electrons[y][x+1];
            break;
        case 2:
            if(y==7)
                {
                i++;
                goto _newcheck;
                }
            k=electrons[y+1][x];
            break;
        case 3:
            if(x==0)
                {
                i++;
                goto _newcheck;
                }
            k=electrons[y][x-1];
            break;
        }

    if(k==0)
        {
        i++;
        goto _newcheck;
        }

    electrons[y][x]--;
    switch(i)
        {
        case 0:
            electrons[y-1][x]--;    
            break;
        case 1:
            electrons[y][x+1]--;    
            break;
        case 2:
            electrons[y+1][x]--;    
            break;
        case 3:
            electrons[y][x-1]--;    
            break;
        }
    i++;
    goto _newcheck;
    }
return 1;
}




/* chf==CHeck Function -- recursive part of checkmolecule() */

char chf(char ax, char ay)
{
fill[ay][ax]=1;

if(atoms[ay][ax]==0)
    return 1;

if(atoms[ay][ax]>0)
    {
    if(electrons[ay][ax]>0)
        return 1;

    if(ay>0)
        if(fill[ay-1][ax]==0)
            if(atoms[ay-1][ax]>0)
                if(chf(ax,ay-1)==1) return 1;
    if(ax<11)
        if(fill[ay][ax+1]==0)
            if(atoms[ay][ax+1]>0)
                if(chf(ax+1,ay)==1) return 1;
    if(ay<7)
        if(fill[ay+1][ax]==0)
            if(atoms[ay+1][ax]>0)
                if(chf(ax,ay+1)==1) return 1;
    if(ax>0)
        if(fill[ay][ax-1]==0)
            if(atoms[ay][ax-1]>0)
                if(chf(ax-1,ay)==1) return 1;
    }

return 0;
}

/* another recursive part for checkmolecule() */

char destroymolecule(char ax, char ay)
{
fill[ay][ax]=1;

if(atoms[ay][ax]==0)
    return 1;

if(atoms[ay][ax]>0)
    {
    if(electrons[ay][ax]>0)
        return 1;

    if(ay>0)
        if(fill[ay-1][ax]==0)
            if(atoms[ay-1][ax]>0)
                if(destroymolecule(ax,ay-1)==1) return 1;
    if(ax<11)
        if(fill[ay][ax+1]==0)
            if(atoms[ay][ax+1]>0)
                if(destroymolecule(ax+1,ay)==1) return 1;
    if(ay<7)
        if(fill[ay+1][ax]==0)
            if(atoms[ay+1][ax]>0)
                if(destroymolecule(ax,ay+1)==1) return 1;
    if(ax>0)
        if(fill[ay][ax-1]==0)
            if(atoms[ay][ax-1]>0)
                if(destroymolecule(ax-1,ay)==1) return 1;
    }

atoms[ay][ax]=5;    /* "delete marker" */
x3++;   /* add to "partial score" */
return 0;
}


/**********************************************************************/
/* checks if molecule complete (beware -- the function is recursive!) */
/**********************************************************************/

char checkmolecule(char bx, char by)
{
for(k=0;k<8;k++)
    for(i=0;i<12;i++)
        fill[k][i]=0;
x3=0;    /* partial score */
if(chf(bx,by)==0)      /* check if molecule complete */
    {
    for(k=0;k<8;k++)
        for(i=0;i<12;i++)
            fill[k][i]=0;
    destroymolecule(bx,by);    /* if it is, nuke it (and increase score) */
    for(k=0;k<8;k++)
        for(i=0;i<12;i++)
            if(atoms[k][i]==5) atoms[k][i]=0;
    return x3;  /* return x to the score formula */
    }
else
    return 0;
}


/* draw cursor function */

void drwc()
{
sprx2(cursor,4,x*8,y*8+2);
oldatom=0;
if(atom>0)
    {
    sprx2(atomspr[atom-1],4,x*8,y*8+2);
    oldatom=atom;
    }
}

void undrwc()
{
sprx2(cursor,4,x*8,y*8+2);
if(oldatom>0)
    sprx2(atomspr[oldatom-1],4,x*8,y*8+2);
}


void adjmax()
{
x3=maxloop;
if(score>250)       /* this should keep the player from */
    {
    maxloop=350;    /* getting too many points =) */
    difficulty=2;
    }
if(score>750)
    {
    maxloop=250;
    difficulty=3;
    }
if(score>1700)
    {
    maxloop=200;
    difficulty=4;
    }
if(score>2500)
    {
    maxloop=170;
    difficulty=5;
    }
if(score>3800)
    {
    maxloop=150;
    difficulty=6;
    }
if(score>6000)
    {
    maxloop=120;
    difficulty=7;
    }
if(score>10000)
    {
    maxloop=100;     /* quite hard trust me! */
    difficulty=8;
    }
if(x3!=maxloop) looper=0; /* or it could wrap around (happened on me once;
                             I had just completed a big molecule and suddendly
                             no more atoms appeared...) */
}


/******************/
/*  main program  */
/******************/

void main()
{
if(teacher==1)
    {
    teacher=0;
    goto _restart;
    }

_mainmenu:

if(score>hiscore) hiscore=score;

clrscr();
invtext();
gotoxy(0,0);
prints("   Nuclei Wars v1.5  ");
prints("   (C) Istar 1997    ");
normtext();
gotoxy(3,3);
prints("F1..F4 - start");
gotoxy(5,4);
prints("F5 - exit");
gotoxy(3,6);
prints("Last score:");
printd(score);
gotoxy(3,7);
prints("Hiscore:   ");
printd(hiscore);
normtext();

while(1)
    {
    key=getch();
    switch(key)
        {
        case K_F1:
            difficulty=1;
            score=0;
            goto _startgame;
        case K_F2:
            difficulty=2;
            score=300;
            goto _startgame;
        case K_F3:
            difficulty=3;
            score=800;
            goto _startgame;
        case K_F4:
            difficulty=4;
            score=1750;
            goto _startgame;
        case K_F5:
        case K_EXIT:
            return;
        case K_SIGN:   /* this is a secret button "fuer die experts only!" */
            hiscore=0;
            score=0;
            goto _mainmenu;
        }
    }

_startgame:

for(k=0;k<8;k++)
    for(i=0;i<12;i++)
        {
        atoms[k][i]=0;
        electrons[k][i]=0;
        fill[k][i]=0;
        }

for(i=0;i<5;i++)
    next[i]=0;

looper=0;

newatom();
getatom();

x=0;
y=0;
looper=0;

maxloop=450;    /* difficulty level 1 start speed */

adjmax();                    /* set starting speed of the game */

/* score=(difficulty-1)*200;    /* "adjust" score before game start */
/* nope, or it will spoil the difficulty level */

_restart:

drawview();
drwc();

/******** game loop ********/

while(1)
    {
    delay(1);
    looper++;

    if(atom==0 && next[0]!=0)
        {
        getatom();
        updnext();
        undrwc();
        drwc();
        }

    if(looper==maxloop)   /* every now and then get a new atom */
        {
        looper=0;
        if(newatom()==1)    /* == if no more free space in next[] */
            {
            invtext();
            gotoxy(5,3);
            prints("GAME OVER");
            key=getch();            /* wait for keypress */
            normtext();
            goto _mainmenu;
            }
        updnext();
        }

    getky=kbhit();

    switch(getky)
        {
        case K_LEFT:
            if(x>0)
                {
                undrwc();
                x--;
                drwc();
                }
            break;
        case K_RIGHT:
            if(x<11)
                {
                undrwc();
                x++;
                drwc();
                }
            break;
        case K_UP:
            if(y>0)
                {
                undrwc();
                y--;
                drwc();
                }
            break;
        case K_DOWN:
            if(y<7)
                {
                undrwc();
                y++;
                drwc();
                }
            break;
        case K_EXIT:
            goto _mainmenu;
        case K_MORE:
            key=getch();
            break;
        case K_DEL:
            teacher=1;
            return;
        case K_SECOND:
            if(placeatom()==0)      /* 0 means success */
                {
                x3=0;
                checkmolecule(x,y);

                if(x3>0)
                    score+=difficulty*x3*(x3/2);

                adjmax();   /* adjust maxloop if necessary */

                getatom();
                drawview();
                drwc();
                }
            break;
        }   /* end of switch */
    }   /* end of game loop */
}   /* end of main() */
